part of tecfy_core_client_package;

class ReportDataService {
  static Future onOpenReport(
      BuildContext context, Map<String, dynamic> report) async {
    // AppNavigator.navigateTo(context, ()=>ReportFilterPage(report));
    List<EntityFilter> filter = [];
    bool canceled = false;
    if (report['filters'].length > 0) {
      var result = await AppNavigator.showAppDialog(
          context,
          (c) => EntityFilterPage(
              //report['name${LocalConfigService.languagePrefex}'],
              report['filters'].map<Property>((r) {
                var prop = Property.getProperty(r);
                //prop.isVisable = true;
                prop?.isAdd = true;
                prop?.isEdit = true;
                //prop.size = true;
                prop?.isDisplayField = true;
                prop?.isGrid = false;
                prop?.readOnly = false;
                prop?.isRequired = r['isRequired'] ?? false;
                return prop;
              }).toList(),
              []));
      if (result == null) canceled = true;
      if ((result as List<EntityFilter>?) == null)
        result = List.empty(growable: true);
      filter = result
              ?.where((f) =>
                  f.value != null && f.property != null && f.operatorId != null)
              .toList() ??
          [];
    }
    if (!canceled) {
      for (var m in report['filters']) {
        if (m['isRequired'] == true &&
            !filter.any((p) => p.propertyName == m['dbName'])) {
          AppNavigator.showMessage(context, 'Data Missing', MessageType.warning,
              message: m['nameAr']);
          return;
        }
      }
      AppNavigator.navigateTo(context, () => ReportDetailPage(report, filter));
    }
  }
}
